/*
 * File:   Process.cpp
 * Author: michael
 * 
 * Created on 24. Oktober 2015, 12:10
 */

#include "Process.h"

using namespace std;
using namespace rsc::logging;
using namespace boost;
using namespace rsbag;

Process::Process(string program, vector<string> arguments, vector<string> environment) :
impl(program, arguments, environment),
logger(Logger::getLogger("rsbag.Process")) {
    
    string arguments_str = "";
    for (int i = 0; i < arguments.size(); i++) {
        arguments_str += arguments[i] + " ";
    }
    string environment_str = "";
    for (int i = 0; i < environment.size(); i++) {
        environment_str += environment[i] + " ";
    }

    RSCINFO(logger, str(format("Opening process %1% with arguments %2% and environment %3%.") % program % arguments_str % environment_str));
}

void Process::start() {
    impl.start();
}

int Process::stop(unsigned int wait_time) {
    if(impl.is_alive()) {
        impl.request_end();
        int result = impl.wait_for_end(wait_time);

        if (!impl.is_exited(result)) {
            impl.force_end();
            return impl.wait_for_end();
        } else {
            return result;
        }
    }
    
    return -1;
}

Process::~Process() {
    RSCDEBUG(logger, "Killing process through deconstructor.");
    
    stop();
}