/* 
 * File:   Process_imp_linux.h
 * Author: michael
 *
 * Created on 24. Oktober 2015, 12:11
 */

#ifndef PROCESS_IMP_LINUX_H
#define	PROCESS_IMP_LINUX_H

#include <ctime>
#include <cstdio>

#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>
#include <errno.h>

#include <exception>
#include <vector>
#include <string>

#include <boost/format.hpp>

#include <rsc/logging/Logger.h>

namespace rsbag {

    class Process_impl {
    public:

        Process_impl(std::string program,
                std::vector<std::string> arguments = std::vector<std::string>(),
                std::vector<std::string> environment = std::vector<std::string>());

        void start();

        bool is_alive();
        
        bool is_exited(int result);

        void request_end();

        void force_end();

        int wait_for_end(unsigned int timeout = 0);

        virtual ~Process_impl();
    private:
        rsc::logging::LoggerPtr logger;
        
        pid_t process;
        std::string program;
        std::vector<std::string> arguments;
        std::vector<std::string> environment;

        char** getAsCharArrayArray(std::vector<std::string>& object);
    };

}

#endif	/* PROCESS_IMP_LINUX_H */

